* srconv.c (wr_hd): Space size within segment was being
[deliverable/binutils-gdb.git] / configure.in
... / ...
CommitLineData
1##############################################################################
2
3## This file is a shell script fragment that supplies the information
4## necessary to tailor a template configure script into the configure
5## script appropriate for this directory. For more information, check
6## any existing configure script.
7
8## Be warned, there are two types of configure.in files. There are those
9## used by Autoconf, which are macros which are expanded into a configure
10## script by autoconf. The other sort, of which this is one, is executed
11## by Cygnus configure.
12
13## For more information on these two systems, check out the documentation
14## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
15
16##############################################################################
17
18### To add a new directory to the tree, first choose whether it is a target
19### or a host dependent tool. Then put it into the appropriate list
20### (library or tools, host or target), doing a dependency sort. For
21### example, gdb requires that byacc (or bison) be built first, so it is in
22### the ${host_tools} list after byacc and bison.
23
24
25# these libraries are used by various programs built for the host environment
26#
27host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
28
29if [ "${enable_gdbgui}" = "yes" ] ; then
30 host_libs="${host_libs} libgui"
31fi
32
33# these tools are built for the host environment
34#
35host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
36 prms send-pr gprof gdbtest tgas etc expect dejagnu sim
37 m4 autoconf ispell grep diff rcs cvs fileutils shellutils
38 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
39 recode release sed utils"
40
41
42# these libraries are built for the target environment, and are built after
43# the host libraries and the host tools (which may be a cross compiler)
44#
45target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
46
47
48# these tools are built using the target libs, and are intended to run only
49# in the target environment
50#
51# note: any program that *uses* libraries that are in the "target_libs"
52# list belongs in this list. those programs are also very likely
53# candidates for the "native_only" list which follows
54#
55target_tools="target-examples target-groff"
56
57################################################################################
58
59## These two lists are of directories that are to be removed from the
60## ${configdirs} list for either cross-compilations or for native-
61## compilations. For example, it doesn't make that much sense to
62## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
63## a native environment.
64
65# directories to be built in the native environment only
66#
67native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
68 indent ispell m4 rcs recode sed shellutils tar textutils gash
69 uudecode wdiff gprof target-groff"
70
71# directories to be built in a cross environment only
72#
73cross_only="target-libiberty target-libgloss target-newlib"
74
75## All tools belong in one of the four categories, and are assigned above
76## We assign ${configdirs} this way to remove all embedded newlines. This
77## is important because configure will choke if they ever get through.
78## ${configdirs} is directories we build using the host tools.
79## ${target_configdirs} is directories we build using the target tools.
80#
81configdirs=`echo ${host_libs} ${host_tools}`
82target_configdirs=`echo ${target_libs} ${target_tools}`
83
84################################################################################
85
86srctrigger=move-if-change
87srcname="gnu development package"
88
89# This gets set non-empty for some net releases of packages.
90appdirs=""
91
92# per-host:
93
94# Work in distributions that contain no compiler tools, like Autoconf.
95if [ -d ${srcdir}/config ]; then
96case "${host}" in
97 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
98 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
99 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
100 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
101 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
102 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
103 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
104 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
105 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
106 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
107 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
108 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
109 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
110 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
111 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
112 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
113 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
114 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
115 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
116 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
117 i[345]86-*-win32) host_makefile_frag=config/mh-i386win32 ;;
118 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
119 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
120 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
121 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
122 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
123 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
124 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
125 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
126 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
127 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
128esac
129fi
130
131# See if we can extract a definition of CC from the fragment.
132if [ -z "${CC}" ]; then
133 if [ -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
134 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
135 if [ -n "${xx}" ] ; then
136 CC=$xx
137 fi
138 fi
139fi
140
141# The Solaris /usr/ucb/cc compiler does not appear to work.
142case "${host}" in
143 sparc-sun-solaris2*)
144 if [ "`/usr/bin/which ${CC-cc}`" = "/usr/ucb/cc" ] ; then
145 could_use=
146 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
147 if [ -d /opt/cygnus/bin ] ; then
148 if [ "$could_use" = "" ] ; then
149 could_use="/opt/cygnus/bin"
150 else
151 could_use="$could_use or /opt/cygnus/bin"
152 fi
153 fi
154 if [ "$could_use" = "" ] ; then
155 echo "Warning: compilation may fail because you're using"
156 echo "/usr/ucb/cc. You should change your PATH or CC "
157 echo "variable and rerun configure."
158 else
159 echo "Warning: compilation may fail because you're using"
160 echo "/usr/ucb/cc, when you should use the C compiler from"
161 echo "$could_use. You should change your"
162 echo "PATH or CC variable and rerun configure."
163 fi
164 fi
165 ;;
166esac
167
168# We default to --with-shared on platforms where -fpic is meaningless.
169# Well, we don't yet, but we will.
170if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
171 case "${target}" in
172 alpha-dec-osf*) enable_shared=yes ;;
173 mips-sgi-irix5*) enable_shared=yes ;;
174 *) enable_shared=no ;;
175 esac
176fi
177
178if [ x${enable_shared} = xyes ]; then
179 waugh=
180 case "${host}" in
181 hppa*) waugh=config/mh-papic ;;
182 i[345]86-*) waugh=config/mh-x86pic ;;
183 *) waugh=config/mh-${host_cpu}pic ;;
184 esac
185 if [ -f ${srcdir}/${waugh} ]; then
186 if [ -n "${host_makefile_frag}" ] ; then
187 cat ${srcdir}/${host_makefile_frag} > mh-frag
188 cat ${srcdir}/${waugh} >> mh-frag
189 host_makefile_frag=mh-frag
190 else
191 host_makefile_frag=${waugh}
192 fi
193 fi
194fi
195
196# per-target:
197
198case "${target}" in
199 v810*) target_makefile_frag=config/mt-v810 ;;
200 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
201 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
202esac
203
204skipdirs=
205gasdir=gas
206use_gnu_ld=
207use_gnu_as=
208
209# some tools are so dependent upon X11 that if we're not building with X,
210# it's not even worth trying to configure, much less build, that tool.
211
212case ${with_x} in
213 yes | "") # the default value for this tree is that X11 is available
214 ;;
215 no)
216 skipdirs="${skipdirs} tk gash"
217 ;;
218 *)
219 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
220 ;;
221esac
222
223# Some tools are only suitable for building in a "native" situation.
224# Those are added when we have a host==target configuration. For cross
225# toolchains, we add some directories that should only be useful in a
226# cross-compiler.
227
228is_cross_compiler=
229
230if [ x"${host}" = x"${target}" ] ; then
231 # when doing a native toolchain, don't build the targets
232 # that are in the 'cross only' list
233 skipdirs="${skipdirs} ${cross_only}"
234 is_cross_compiler=no
235 target_subdir=.
236else
237 # similarly, don't build the targets in the 'native only'
238 # list when building a cross compiler
239 skipdirs="${skipdirs} ${native_only}"
240 is_cross_compiler=yes
241 target_subdir=${target_alias}
242 if [ ! -d ${target_subdir} ] ; then
243 if mkdir ${target_subdir} ; then true
244 else
245 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
246 exit 1
247 fi
248 fi
249fi
250
251copy_dirs=
252
253# Handle --with-headers=XXX. The contents of the named directory are
254# copied to $(tooldir)/sys-include.
255if [ x"${with_headers}" != x ]; then
256 if [ x${is_cross_compiler} = xno ]; then
257 echo 1>&2 '***' --with-headers is only supported when cross compiling
258 exit 1
259 fi
260 case "${exec_prefixoption}" in
261 "") x=${prefix} ;;
262 *) x=${exec_prefix} ;;
263 esac
264 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
265fi
266
267# Handle --with-libs=XXX. Multiple directories are permitted. The
268# contents are copied to $(tooldir)/lib.
269if [ x"${with_libs}" != x ]; then
270 if [ x${is_cross_compiler} = xno ]; then
271 echo 1>&2 '***' --with-libs is only supported when cross compiling
272 exit 1
273 fi
274 # Copy the libraries in reverse order, so that files in the first named
275 # library override files in subsequent libraries.
276 case "${exec_prefixoption}" in
277 "") x=${prefix} ;;
278 *) x=${exec_prefix} ;;
279 esac
280 for l in ${with_libs}; do
281 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
282 done
283fi
284
285# If both --with-headers and --with-libs are specified, default to
286# --without-newlib.
287if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
288 if [ x"${with_newlib}" = x ]; then
289 with_newlib=no
290 fi
291fi
292
293# Recognize --with-newlib/--without-newlib.
294if [ x${with_newlib} = xno ]; then
295 skipdirs="${skipdirs} target-newlib"
296elif [ x${with_newlib} = xyes ]; then
297 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
298fi
299
300# Default to using --with-stabs for certain targets.
301if [ x${with_stabs} = x ]; then
302 case "${target}" in
303 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
304 with_stabs=yes;
305 withoptions="${withoptions} --with-stabs"
306 ;;
307 esac
308fi
309
310# Handle ${copy_dirs}
311set fnord ${copy_dirs}
312shift
313while [ $# != 0 ]; do
314 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
315 :
316 else
317 echo Copying $1 to $2
318
319 # Use the install script to create the directory and all required
320 # parent directories.
321 if [ -d $2 ]; then
322 :
323 else
324 echo >config.temp
325 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
326 fi
327
328 # Copy the directory, assuming we have tar.
329 # FIXME: Should we use B in the second tar? Not all systems support it.
330 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
331
332 # It is the responsibility of the user to correctly adjust all
333 # symlinks. If somebody can figure out how to handle them correctly
334 # here, feel free to add the code.
335
336 echo $1 > $2/COPIED
337 fi
338 shift; shift
339done
340
341# Configure extra directories which are host specific
342
343case "${host}" in
344 i[345]86-*-win32* | i[345]86-*-go32*)
345 configdirs="$configdirs dosrel" ;;
346esac
347
348# Remove more programs from consideration, based on the host or
349# target this usually means that a port of the program doesn't
350# exist yet.
351
352noconfigdirs=""
353
354case "${host}" in
355 i[345]86-*-vsta)
356 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
357 ;;
358 i[345]86-*-go32)
359 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
360 ;;
361 i[345]86-*-win32)
362 noconfigdirs="patch diff flex make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
363 ;;
364 ppc*-*-pe)
365 noconfigdirs="patch diff flex make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
366 ;;
367esac
368
369
370case "${target}" in
371 *-*-netware)
372 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty"
373 ;;
374 *-*-vxworks*)
375 noconfigdirs="$noconfigdirs target-newlib"
376 ;;
377 alpha-dec-osf*)
378 # ld works, but does not support shared libraries. emacs doesn't
379 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
380 # gas doesn't generate exception information.
381 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib"
382 ;;
383 alpha*-*-*)
384 # newlib is not 64 bit ready
385 noconfigdirs="$noconfigdirs target-newlib"
386 ;;
387# start-sanitize-arc
388 arc-*-*)
389 ;;
390# end-sanitize-arc
391 arm-*-pe*)
392 ;;
393 arm-*-riscix*)
394 noconfigdirs="$noconfigdirs ld"
395 ;;
396 h8300*-*-* | \
397 h8500-*-*)
398 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
399 ;;
400 hppa*-*-*elf* | \
401 hppa*-*-lites*)
402 # Do configure ld/binutils/gas for this case.
403 ;;
404 hppa*-*-*)
405 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
406 # cc is gcc, and on any system a user should be able to link cc to
407 # whatever they want. FIXME, emacs emacs19).
408 case "${CC}" in
409 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
410 *) ;;
411 esac
412 noconfigdirs="$noconfigdirs ld shellutils"
413 ;;
414 i[345]86-*-go32)
415 # but don't build gdb
416 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
417 ;;
418
419 i[345]86-*-win32)
420 # Can't build gdb for win32 if not native.
421 # make/glob's configure uses some AC_TRY_RUN type tests
422 target_configdirs="$target_configdirs target-winsup"
423 noconfigdirs="$noconfigdirs gdb tcl tk expect make"
424 # always build newlib.
425 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
426 ;;
427 i[345]86-*-pe)
428 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
429 ;;
430 i[345]86-*-sco*)
431 noconfigdirs="$noconfigdirs gprof"
432 ;;
433 i[345]86-*-solaris2*)
434 # The linker does static linking correctly, but the Solaris C library
435 # has bugs such that some important functions won't work when statically
436 # linked. (See man pages for getpwuid, for example.)
437 noconfigdirs="$noconfigdirs ld"
438 ;;
439 i[345]86-*-sysv4*)
440 # The SYSV4 C compiler doesn't handle Emacs correctly
441 case "${CC}" in
442 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
443 *) ;;
444 esac
445 # but that's okay since emacs doesn't work anyway
446 noconfigdirs="$noconfigdirs emacs emacs19"
447 ;;
448 powerpc-*-aix*)
449 # copied from rs6000-*-* entry
450 noconfigdirs="$noconfigdirs gprof cvs"
451 ;;
452 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
453 target_configdirs="$target_configdirs target-winsup"
454 noconfigdirs="$noconfigdirs gdb tcl tk make expect"
455 # always build newlib.
456 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
457 ;;
458 rs6000-*-lynxos*)
459 # The CVS server code doesn't work on the RS/6000
460 # Newlib makes problems for libg++ in crosses.
461 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
462 ;;
463 rs6000-*-*)
464 noconfigdirs="$noconfigdirs gprof"
465 ;;
466 m68k-*-netbsd*)
467 noconfigdirs="$noconfigdirs gdb"
468 ;;
469 m68k-apollo-*)
470 noconfigdirs="$noconfigdirs ld binutils gprof"
471 ;;
472 mips*-*-irix5*)
473 # The GNU linker does not support shared libraries.
474 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
475 noconfigdirs="$noconfigdirs ld gprof emacs"
476 ;;
477 mips*-dec-bsd*)
478 noconfigdirs="$noconfigdirs gprof"
479 ;;
480 mips*-*-bsd*)
481 noconfigdirs="$noconfigdirs gprof"
482 ;;
483 mips*-*-*)
484 noconfigdirs="$noconfigdirs gprof"
485 ;;
486 romp-*-*)
487 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes"
488 ;;
489 sh-*-*)
490 case "${host}" in
491 i[345]86-*-vsta) ;; # don't add gprof back in
492 i[345]86-*-go32) ;; # don't add gprof back in
493 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
494 esac
495 ;;
496 sparc-*-sunos4*)
497 if [ x${is_cross_compiler} != xno ] ; then
498 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib"
499 else
500 use_gnu_ld=no
501 fi
502 ;;
503 v810-*-*)
504 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes"
505 ;;
506 vax-*-vms)
507 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes"
508 ;;
509 vax-*-*)
510 noconfigdirs="$noconfigdirs target-newlib"
511 ;;
512 *-*-lynxos*)
513 # Newlib makes problems for libg++ in crosses.
514 noconfigdirs="$noconfigdirs target-newlib"
515 ;;
516 *-*-macos* | \
517 *-*-mpw*)
518 # Macs want a resource compiler.
519 configdirs="$configdirs grez"
520 ;;
521esac
522
523# If we are building a Canadian Cross, discard tools that can not be built
524# using a cross compiler. FIXME: These tools should be fixed.
525if [ "${build}" != "${host}" ]; then
526 noconfigdirs="$noconfigdirs expect dejagnu make texinfo diff"
527fi
528
529# Make sure we don't let GNU ld be added if we didn't want it.
530if [ x$with_gnu_ld = xno ]; then
531 use_gnu_ld=no
532 noconfigdirs="$noconfigdirs ld"
533fi
534
535# Make sure we don't let GNU as be added if we didn't want it.
536if [ x$with_gnu_as = xno ]; then
537 use_gnu_as=no
538 noconfigdirs="$noconfigdirs gas"
539fi
540
541# Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
542# $target_configdirs.
543# If we have the source for $noconfigdirs entries, add them to $notsupp.
544
545notsupp=""
546for dir in . $skipdirs $noconfigdirs ; do
547 dirname=`echo $dir | sed -e s/target-//g`
548 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
549 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
550 if [ -r $srcdir/$dirname/configure ] \
551 || [ -r $srcdir/$dirname/configure.in ]; then
552 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
553 true
554 else
555 notsupp="$notsupp $dir"
556 fi
557 fi
558 fi
559 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
560 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
561 if [ -r $srcdir/$dirname/configure ] \
562 || [ -r $srcdir/$dirname/configure.in ]; then
563 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
564 true
565 else
566 notsupp="$notsupp $dir"
567 fi
568 fi
569 fi
570done
571
572# Sometimes the tools are distributed with libiberty but with no other
573# libraries. In that case, we don't want to build target-libiberty.
574if [ -n "${target_configdirs}" ]; then
575 others=
576 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
577 if [ "$i" != "libiberty" ]; then
578 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
579 others=yes;
580 break;
581 fi
582 fi
583 done
584 if [ -z "${others}" ]; then
585 target_configdirs=
586 fi
587fi
588
589# Deconfigure all subdirectories, in case we are changing the
590# configuration from one where a subdirectory is supported to one where it
591# is not.
592if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
593 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
594 rm -f $i/Makefile
595 done
596fi
597if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
598 for i in `echo ${target_configdirs} | sed -e s/target-//` ; do
599 rm -f ${target_subdir}/$i/Makefile
600 done
601fi
602
603# Produce a warning message for the subdirs we can't configure.
604# This isn't especially interesting in the Cygnus tree, but in the individual
605# FSF releases, it's important to let people know when their machine isn't
606# supported by the one or two programs in a package.
607
608if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
609 # If $appdirs is non-empty, at least one of those directories must still
610 # be configured, or we error out. (E.g., if the gas release supports a
611 # specified target in some subdirs but not the gas subdir, we shouldn't
612 # pretend that all is well.)
613 if [ -n "$appdirs" ]; then
614 for dir in $appdirs ; do
615 if [ -r $dir/Makefile.in ]; then
616 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
617 appdirs=""
618 break
619 fi
620 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
621 appdirs=""
622 break
623 fi
624 fi
625 done
626 if [ -n "$appdirs" ]; then
627 echo "*** This configuration is not supported by this package." 1>&2
628 exit 1
629 fi
630 fi
631 # Okay, some application will build, or we don't care to check. Still
632 # notify of subdirs not getting built.
633 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
634 echo " ${notsupp}" 1>&2
635 echo " (Any other directories should still work fine.)" 1>&2
636fi
637
638# Set with_gnu_as and with_gnu_ld as appropriate.
639#
640# This is done by determining whether or not the appropriate directory
641# is available, and by checking whether or not specific configurations
642# have requested that this magic not happen.
643#
644# The command line options always override the explicit settings in
645# configure.in, and the settings in configure.in override this magic.
646#
647# If the default for a toolchain is to use GNU as and ld, and you don't
648# want to do that, then you should use the --without-gnu-as and
649# --without-gnu-ld options for the configure script.
650
651if [ x${use_gnu_as} = x ] ; then
652 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
653 with_gnu_as=yes
654 withoptions="$withoptions --with-gnu-as"
655 fi
656fi
657
658if [ x${use_gnu_ld} = x ] ; then
659 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
660 with_gnu_ld=yes
661 withoptions="$withoptions --with-gnu-ld"
662 fi
663fi
664
665if [ x${enable_shared} = xyes ]; then
666 case "${target}" in
667 hppa*) target_makefile_frag=config/mt-papic ;;
668 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
669 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
670 esac
671fi
672
673# post-target:
674
675# Make sure that the compiler is able to generate an executable. If it
676# can't, we are probably in trouble. We don't care whether we can run the
677# executable--we might be using a cross compiler--we only care whether it
678# can be created. At this point the main configure script has set CC.
679echo "int main () { return 0; }" > conftest.c
680${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
681if [ $? = 0 ] && [ -s conftest ]; then
682 :
683else
684 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
685 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
686 rm -f conftest*
687 exit 1
688fi
689rm -f conftest*
690
691# Record target_configdirs and the configure arguments in Makefile.
692target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
693targargs=`echo "${arguments}" | \
694 sed -e 's/--norecursion//' \
695 -e 's/--cache[a-z-]*=[^ ]*//' \
696 -e 's/--ho[a-z-]*=[^ ]*//' \
697 -e 's/--ta[a-z-]*=[^ ]*//'`
698
699# Passing a --with-cross-host argument lets the target libraries know
700# whether they are being built with a cross-compiler or being built
701# native. However, it would be better to use other mechanisms to make the
702# sorts of decisions they want to make on this basis. Please consider
703# this option to be deprecated. FIXME.
704if [ x${is_cross_compiler} = xyes ]; then
705 targargs="--with-cross-host=${host_alias} ${targargs}"
706fi
707
708targargs="--host=${target_alias} ${targargs}"
709sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
710 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
711 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
712 Makefile > Makefile.tem
713rm -f Makefile
714mv -f Makefile.tem Makefile
715
716#
717# Local Variables:
718# fill-column: 131
719# End:
720#
This page took 0.03603 seconds and 4 git commands to generate.